#include <Wire.h>
#include <LiquidCrystal_I2C.h>

char freePlay[] = "FREE PLAY";
char challenge[] = "CHALLENGE MODE";
char motivation[] = "you can do it!";
char gameOver[] = "GAME OVER";
char youWon[] = "** YOU WON! **";
byte heart[8] = {
  0b00000,
  0b01010,
  0b11111,
  0b11111,
  0b01110,
  0b00100,
  0b00000,
  0b00000
};

LiquidCrystal_I2C lcd(0x27, 16, 2);

const int buzzer = 10;
const int circuit = 9;
const int changeButton = 2;
int mode = 1;
int showTimer = 20;
int timerTime = showTimer;
const int stopCountdown = 3;
bool countdown = false;

unsigned long previousMillis = 0;
const long interval = 1000;
int buzzed = 0;

void setup() {
  // put your setup code here, to run once:
  lcd.init();
  lcd.backlight();
  pinMode(buzzer, OUTPUT);
  pinMode(circuit, INPUT);
  pinMode(changeButton, INPUT);
  pinMode(stopCountdown, INPUT);
  showFreePlay();
  lcd.createChar(0, heart);
}

void loop() {
  // put your main code here, to run repeatedly:

  if (digitalRead(circuit) == HIGH) {
    digitalWrite(buzzer, HIGH);
  } else {
    digitalWrite(buzzer, LOW);
  }

  if (digitalRead(changeButton) == HIGH) {
    changeMode();
    delay(500);
  }

  unsigned long currentMillis = millis();
  if (mode == 2) {
    if (currentMillis - previousMillis >= interval && countdown == true) {
      previousMillis = currentMillis;
      if (showTimer > 0) {
        showCountdown();
      } else {
        lcd.setCursor(3, 1);
        lcd.print(gameOver);
        if (buzzed == 0) {
          digitalWrite(buzzer, HIGH);
          delay(1500);
          digitalWrite(buzzer, LOW);
          buzzed = 1;
        }
      }
    }
    if (digitalRead(stopCountdown) == HIGH) {
      countdown = false;
      lcd.clear();
      lcd.setCursor(1,1);
      lcd.print(youWon);
    }
  }
}

void showFreePlay() {
  lcd.setCursor(3, 0);
  lcd.print(freePlay);
  lcd.setCursor(0, 1);
  lcd.print(motivation);
  lcd.write((byte)0);
  showTimer = timerTime;
}

void showChallenge() {
  lcd.setCursor(1, 0);
  lcd.print(challenge);
}

void changeMode() {
  if (mode == 1) {
    mode = 2;
    lcd.clear();
    buzzed = 0;
    countdown = true;
    showChallenge();
  } else {
    mode = 1;
    lcd.clear();
    showFreePlay();
  }
}

void showCountdown() {
  if (showTimer >= 10) {
    lcd.setCursor(7, 1);
    lcd.print("");
    lcd.print(showTimer);
  }
  if (showTimer < 10) {
    lcd.setCursor(7, 1);
    lcd.print("  ");
    lcd.setCursor(8, 1);
    lcd.print(showTimer);
  }
  showTimer--;
}